/*
 Languages for Scientific Computing
 ----
*/
// to compile:
// gcc -o outputname -Wall test12.c 


#include <stdlib.h>   // (almost) always necessary
#include <stdio.h>    // (almost) always necessary



/* the MAIN program starts here */

int main(int argc, char *argv[] )
{
   // #12  static matrices  (use dynamic!)

   double mat1[3][6];

   int i, j; 
   for( i=0; i<3; i++ )
      for( j=0; j<6; j++ )
	 printf( "mat1[%d, %d]: %g\n", i, j, mat1[i][j] );



   double mat2[2][3] = 
      {
	 {3.4, 12.2, -.555},
	 {7.7}
      };

   for( i=0; i<2; i++ )
      for( j=0; j<3; j++ )
	 printf( "mat2[%d, %d]: %g\n", i, j, mat2[i][j] );


      
   double mat3[][3] = 
      {
	 {3.4, 12.2, -.555},
	 {7.7, 77.7}
      };

   for( i=0; i<2; i++ )
      for( j=0; j<3; j++ )
	 printf( "mat3[%d, %d]: %g\n", i, j, mat3[i][j] );



   double mat4[][3] = 
      {
	 {3.4, 12.2, -.555},
	 {7.7, 77.7},
	 {1, 2, 3, 4}
      };

   for( i=0; i<3; i++ )
      for( j=0; j<4; j++ )
	 printf( "mat4[%d, %d]: %g\n", i, j, mat4[i][j] );


   

   int m, n;
   if(argc < 3) printf(" arguments needed: pass me two integers\n");
   if(argc >= 3)  {m = atoi(argv[1]); n = atoi(argv[2]);}

   double mat[m][n];

   for( i=0; i<m; i++ )
      for( j=0; j<n; j++ )
	 printf( "mat[%d, %d]: %g\n", i, j, mat[i][j] );


  return( 0 );
}

